<?php
/*
 * ϻβФ
 */
require_once '../../data/constant.php';
require_once '../../data/db_access.php';
require_once '../../data/table_access.php';
ini_set("session.save_handler","files");
ini_set('session.use_trans_sid', '1');
session_start();
if (!isset($_SESSION[SESSION_USR])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."usr/login.php");
	exit;
}
$ses_arr = $_SESSION[SESSION_USR];
$st_nam = htmlspecialchars($ses_arr['student_nam'],ENT_QUOTES);
$student_id = $ses_arr['student_id'];

if (!isset($_SESSION["moshi_list_arr"]) || !isset($_POST["moshi_id"]) ||
!isset($_POST["start_time"])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."usr/index.php");
	exit;
}

$moshi_id = "";
$start_time = "";
$duration = "";
$end_time = time();
$is_timeover = 0;
$err_msg="";
$total_score = 0;
$ans_ind_arr = array();
$prac_item_object = null;
$prac_key_object = null;
$moshi_list_arr= array();
if (is_array($_SESSION["moshi_list_arr"])) $moshi_list_arr = $_SESSION["moshi_list_arr"];

unset($_SESSION["moshi_list_arr"]);
$moshi_id = $_POST["moshi_id"];
$start_time = $_POST["start_time"];
if (($end_time-$start_time)>= ($duration*60)) {
	//ڤˤʤä
	$is_timeover = 1;
}

$data_object = new CDbAccess();
if ($data_object->openDB() == false) {
	$err_msg .= $data_object->err_msg;
} else {
	if ($data_object->transactionBegin()) {
		$prac_res_object = new CPracResTableAccess();
		mb_regex_encoding("UTF-8");

		foreach ($moshi_list_arr as $key=>$val) {
			//echo "Enter".$val["answer"]."<br/>";
			//å
			$is_right=0;
			$answered = $val["answer"];
			$practice_id = $val["practice_id"];
			$department = $val["department"];
			$tmp_ind_arr = array();
			if ($val["ans_type"] == 1) {
				//
				if (is_null($prac_item_object)) $prac_item_object = new CPracItemTableAccess();
				if (!$prac_item_object->setRightItemPerPrac($data_object->conn, $practice_id)) {
					$err_msg .= "Failed to GET ITEM DATA<br/>";
					break;
				} else {
					while ($res = $prac_item_object->dbFetchArr()) {
						if ($res["item_order"] == trim($answered)) {
							$is_right = 1;
							break;
						}
					}
					$prac_item_object->dbFreeResult();
				}
			} else if ($val["ans_type"] == 2) {
				//ʣ
				if (!is_null($answered) && $answered <> "") {
				sort($answered);
				if (is_null($prac_item_object)) $prac_item_object = new CPracItemTableAccess();
				if (!$prac_item_object->setRightItemPerPrac ($data_object->conn, $practice_id)) {
					$err_msg .= "Failed to GET ITEM DATA<br/>";
					break;
				} else {
					$tmp_answered = $answered;
					while ($res = $prac_item_object->dbFetchArr()) {
						if (!in_array($res["item_order"], $answered)) {
							break;
						}
						array_shift($tmp_answered);
					}
					if (count($tmp_answered) == 0) $is_right = 1;
//					var_dump($answered);
//					echo "<p/>";
					$prac_item_object->dbFreeResult();
					$answered = join(",",$answered);
//					var_dump($answered);
//					echo "<p/>";
				}
				}

			} else if ($val["ans_type"] == 0 || $val["ans_type"] == 3 || $val["ans_type"] == 4) {
				//ɤ
				if (is_null($prac_key_object)) $prac_key_object = new CPracKeyWordTableAccess();
				if (!$prac_key_object->setKeyWordPerPracticeArr ($data_object->conn, $practice_id)) {
					$err_msg .= "Failed to GET KEY WORD DATA<br/>";
					break;
				} else {
					$is_right = 1;
					while ($res = $prac_key_object->dbFetchArr()) {
						if (!mb_ereg($res["key_word_txt"],trim($answered))) {
							$is_right = 0;
							break;
						}
					}
					$prac_key_object->dbFreeResult();
				}
			} else if ($val["ans_type"] == 5) {
				//ɤ줫ĤOK
				if (is_null($prac_key_object)) $prac_key_object = new CPracKeyWordTableAccess();
				if (!$prac_key_object->setKeyWordPerPracticeArr ($data_object->conn, $practice_id)) {
					$err_msg .= "Failed to GET KEY WORD DATA<br/>";
					break;
				} else {
					while ($res = $prac_key_object->dbFetchArr()) {
						if (mb_ereg($res["key_word_txt"],trim($answered))) {
							$is_right = 1;
							break;
						}
					}
					$prac_key_object->dbFreeResult();
				}
			} else {
				//ɤ줫ȴ
				if (is_null($prac_key_object)) $prac_key_object = new CPracKeyWordTableAccess();
				if (!$prac_key_object->setKeyWordPerPracticeArr ($data_object->conn, $practice_id)) {
					$err_msg .= "Failed to GET KEY WORD DATA<br/>";
					break;
				} else {
					while ($res = $prac_key_object->dbFetchArr()) {
						if ($res["key_word_txt"] == trim($answered)) {
							$is_right = 1;
							break;
						}
					}
					$prac_key_object->dbFreeResult();
				}
			}

			$practice_result_id = 0;
			//Practice Result
			if ($is_timeover <> 1 || $answered <> "") {
				//४СϤǤʤäɬʬʤä櫓ǤϤʤΤǡϿʤ

			//	echo "Regist".$answered."<br/>";

				if (!$prac_res_object->insertPracResDataMoshi(
				$data_object->conn,$student_id,
				$practice_id,$answered,$is_right,$department)) {
					$err_msg .= "Failed to Insert Practice Result<br/>";
					break;
				}
				$practice_result_id = $prac_res_object->getLatestId("practice_result_id",$data_object->conn);
			}
			$tmp_score = ($is_right * $val["score"]);
			$total_score += $tmp_score;

			$tmp_ind_arr["ans_order"] = intval($key);
			$tmp_ind_arr["practice_id"] = $practice_id;
			$tmp_ind_arr["moshi_quiz_type_id"] = $val["moshi_quiz_type_id"];
			$tmp_ind_arr["prac_result_id"] = $practice_result_id;
			//ɲ
			//$tmp_ind_arr["question_id"] = $question_id;
			$tmp_ind_arr["answered"] = $answered;
			$tmp_ind_arr["is_right"] = $is_right;
			$tmp_ind_arr["get_score"] = $tmp_score;

			array_push($ans_ind_arr,$tmp_ind_arr);

		}
//echo "1st END<br/>";
		if ($err_msg == "") {
			$moshi_whole_ans_object = new CAnsToWholeMoshiTableAccess();
			$whole_moshi_id = 0;
			//echo "REG WHOLE<br/>";
			if (!$moshi_whole_ans_object->insertWholeAnsExe(
				$data_object->conn,$moshi_id,
					($end_time-$start_time),$total_score,$student_id)) {
				$err_msg .= "Failed to Insert Whole Moshi<br/>";
			} else {
				$whole_moshi_id =
					$moshi_whole_ans_object->getLatestId(
					"ansto_whole_moshi_id",$data_object->conn);
			}
		//	echo "REG IND<br/>";
			if ($err_msg == "" && count($ans_ind_arr)>0) {
				$iam_object = new CIndAnstoMoshiTableAccess();
				foreach ($ans_ind_arr as $child) {
					if (!$iam_object->insertIndAnstoMoshiExe(
					$data_object->conn,$whole_moshi_id,$child["practice_id"],
					$child["moshi_quiz_type_id"],$child["prac_result_id"],
					$child["ans_order"],$child["answered"],$child["is_right"],
					$child["get_score"])){
						$err_msg .= "Failed to Insert IndAns<br/>";
					}
				}
			}
		}

		if ($err_msg <> "") {
			$data_object->transactionRollBack();
		} else {
			$data_object->transactionCommit();
		}
	}

	$data_object->closeDB();
}

if ($err_msg <> "") {
	echo $err_msg;
} else {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."usr/moshi/view_one_moshi_result.php?whole_moshi_id=".$whole_moshi_id."&moshi_id=".$moshi_id);
	exit;
}

?>