<?php
require_once '../../data/constant.php';
require_once '../../data/db_access.php';
require_once '../../data/table_access.php';

session_start();
if (!isset($_SESSION[SESSION_USR])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."usr/login.php");
	exit;
}

$ses_arr = $_SESSION[SESSION_USR];
//桼ξ
$st_nam = $ses_arr['student_nam'];
$st_id	= $ses_arr['student_id'];
$st_status = $ses_arr['status'];
$st_grade = $ses_arr['grade'];

$act_type = "";
$err_msg = "";

$practice_id = "";
$back_file ="";

if ($_POST <> null) {
	if (isset($_POST['action_type'])) {
		if ($_POST['action_type'] == "create" || $_POST['action_type'] == "edit") {
			$act_type = $_POST['action_type'];
		}
	}
}

if ($_GET <> null && isset($_GET['action_type'])) {
	$act_type =$_GET['action_type'];
}

//񤭹ߥե
$write_img = DOC_ROOT."img_files/";
$img_dir = "";
if ($_POST["practice_id"] <> "" && $_POST["text_id"] =="") {
	$img_dir = DOC_ROOT."img_files/prac_".$_POST["practice_id"];
} else if ($_POST["practice_id"] == "" && $_POST["text_id"] <>"") {
	$img_dir = DOC_ROOT."img_files/".$_POST["text_id"];
}

$write_av = DOC_ROOT."av_files/";
$av_dir = "";

if ($_POST["practice_id"] <> "" && $_POST["text_id"] =="") {
	$av_dir = DOC_ROOT."av_files/prac_".$_POST["practice_id"];
} else if ($_POST["practice_id"] == "" && $_POST["text_id"] <>"") {
	$av_dir = DOC_ROOT."av_files/".$_POST["text_id"];
}
if (isset($_SESSION["tmp_av"])) {
	//AVξ
	$av_dir = DOC_ROOT."av_files/".$_SESSION["tmp_av"];
	unset($_SESSION["tmp_av"]);
}

if (isset($_SESSION["tmp_img"])) {
	//᡼ξ
	$img_dir = DOC_ROOT."img_files/".$_SESSION["tmp_img"];
	unset($_SESSION["tmp_img"]);
	//$img_dir = DOC_ROOT."img_files/prac_".$_POST["practice_id"];
}

if ($act_type <> "create" && $act_type <> "edit") {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."usr/login.php");
	exit;
} else {
	$data_object = new CDbAccess();
		//DB³
	if ($data_object->openDB() == false) {
		$err_msg .= $data_object->err_msg;
	} else {
		//ꥪ֥Ȥ
		$prac_object = new CPracTableAccess();
		if (!isset($_POST['ans_txt']) || !is_numeric($_POST['ans_txt'])) {
			$err_msg .= "Irregular Parameter<br/>";
		} else {
			//if ($_POST['ans_txt'] == 0) {
			if ($_POST['ans_txt'] == 0 || $_POST['ans_txt'] == 5) {
				$item_object = new CPracKeyWordTableAccess();
			} else {
				$item_object = new CPracItemTableAccess();
			}
		}

		if ($err_msg == "" && $data_object->transactionBegin()) {
			/*
			if ($act_type == "insert" || $act_type == "from_question") {
				if (!$prac_object->insertPracDataFromTeaExe($data_object->conn, $_POST, $ses_arr['teacher_id'])) {
					$err_msg = "Failed to Insert Practice Data<br>";
					$err_msg .= $prac_object->err_msg;
				} else {
					$practice_id = $prac_object->getLatestId("practice_id", $data_object->conn);
				}
			} else if ($act_type == "update" && isset($_POST['up_id']) && is_numeric($_POST['up_id'])) {
				if (!$prac_object->updatePracDataFromTeaExe ($data_object->conn, $_POST)) {
					$err_msg = "Failed to Update Practice Data<br>";
				} else {
					$practice_id = $_POST['up_id'];
					$item_object->deletePracByInsert($data_object->conn, $practice_id);
				}
			}
			*/

			if ($act_type == "create") {
				if (!$prac_object->insertPracDataFromStuExe($data_object->conn, $_POST, $st_id)) {
					$err_msg = "Failed to Insert Practice Data<br>";
					$err_msg .= $prac_object->err_msg;
				} else {
					$practice_id = $prac_object->getLatestId("practice_id", $data_object->conn);
				}
			} else if ($act_type == "edit") {
				if (!$prac_object->updatePracDataFromStuExe ($data_object->conn, $_POST,$st_id)) {
					$err_msg = "Failed to Update Practice Data<br>";
				} else {
					$practice_id = $_POST['practice_id'];
					$item_object->deletePracByInsert($data_object->conn, $practice_id);
				}
			}
			if (!is_numeric($practice_id)) {
				$err_msg .= "Irregular Prameter";
			} else {
								//if ($_POST['ans_txt'] == 0) {
				if ($_POST['ans_txt'] == 0 || $_POST['ans_txt'] == 5) {
					for ($i=0; $i< 10; $i++) {
						if (isset($_POST["key_word".$i]) && $_POST["key_word".$i] <> "") {
						if (!$item_object->insertKeywordExe ($data_object->conn, $practice_id,$_POST["key_word".$i])) {
							$err_msg .= "Failed to Insert KeyWord";
							break;
						}
						}
					}
				} else {
					for ($i=0; $i< 10; $i++) {
						if (isset($_POST["item_bango".$i]) && $_POST["item_bango".$i] <> "") {
						if (!$item_object->insertPracItemExe ($data_object->conn,
							$practice_id,
							$_POST["item_bango".$i],
							$_POST["item_txt".$i], $_POST["is_right".$i])) {
							$err_msg .= "";
							break;
						}
						}
					}
				}
			}
							//
			if ($err_msg == "") {
		//顼ʤˤϡեν񤭹
				if ($_POST['img_file'] <> "") {
					if (!mb_ereg("\.gif|\.jpg|\.jpeg|\.png|\.bmp$",$_POST['img_file'])) {
						$err_msg .="File Type Error<br/>";
					} else {

						if (!is_dir($write_img."prac_".$practice_id)) {
							mkdir($write_img."prac_".$practice_id,0777);
						}
						if (is_dir($img_dir)) {
						if (!copy($img_dir."/".$_POST['img_file'], $write_img."prac_".$practice_id."/".$_POST['img_file'])) {
							//$err_msg .="᡼ե񤭹߼";
						}
						//if (!mb_ereg("prac_",$img_dir)) {
						if (!mb_ereg("prac_",$img_dir) && $_POST["text_id"] == "" && $_POST["practice_id"] <> "") {
							unlink($img_dir."/".$_POST['img_file']);
							rmdir($img_dir);
						}
						}
					}
				}

				if ($_POST['av_file'] <> "") {
					if (!mb_eregi("\.asf|\.wma|\.wmv|\.asx|\.wax|\.wvx|\.cda|\.mid|\.midi|\.wav|\.snd|\.au|\.aif|\.aifc|\.aiff|\.avi|\.mpg|\.mpeg|\.mp3|\.mp4|\.mov|\.swf|\.flv$",$_POST['av_file'])) {
						$err_msg .="File Type Error<br/>";
					} else {
						if (!is_dir($write_av."prac_".$practice_id)) {
							mkdir($write_av."prac_".$practice_id,0777);
						}
						if (is_dir($av_dir)) {
							/*
						if (!copy($av_dir."/".$_POST['av_file'], $write_av."prac_".$practice_id."/".$_POST['av_file'])) {
							$err_msg .=_EXAM_TEA_AV_COPY_ERR;
						}
						*/
						copy($av_dir."/".$_POST['av_file'], $write_av."prac_".$practice_id."/".$_POST['av_file']);
						if (!mb_ereg("prac_",$av_dir) && $_POST["text_id"] == "" && $_POST["practice_id"] <> "") {
							unlink($av_dir."/".$_POST['av_file']);
							rmdir($av_dir);
						}
						}
					}
				}
			}
			if ($err_msg == "") {
				$data_object->transactionCommit();
			} else {
				$data_object->transactionRollBack();
			}
		}
		$data_object->closeDB();
	}
}
if ($err_msg == "") {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."usr/practice/index.php");
	exit;
}
echo $err_msg;
?>