<?php
require_once '../../data/constant.php';
require_once '../../util/make_item.php';
require_once '../../util/validate.php';
require_once '../../data/db_access.php';
require_once '../../data/table_access.php';
require_once '../../util/validate.php';
require_once '../../util/change_util.php';

ini_set("session.save_handler","files");
ini_set('session.use_trans_sid', '1');
session_start();

//Ӥؤб
$mobile_id = "";
$agent = $_SERVER['HTTP_USER_AGENT'];

if (mb_ereg("^DoCoMo", $agent)){
	$sis_id="?".session_name()."=".session_id();
	$mobile_id = $_SERVER['HTTP_X_DCMGUID'];
	$display_items = "none";
	//$is_mob=1;
} else {
	if(mb_ereg("^J-PHONE|^Vodafone|^SoftBank", $agent)){
  		$mobile_id = $_SERVER['HTTP_X_JPHONE_UID'];
  		$display_items = "none";
  		//$is_mob=1;
	}else if(mb_ereg("^UP.Browser|^KDDI", $agent)){
  		$mobile_id = $_SERVER['HTTP_X_UP_SUBNO'];
  		$display_items = "none";
  		//$is_mob=1;
	} else {
		$display_items = "inline";
	}
	$sis_id = "";
}

if (!isset($_SESSION[SESSION_USR]) && $mobile_id<>"") {
	$data_object = new CDbAccess();
	if ($data_object->openDB() == false) {
		$err_msg .= $data_object->err_msg;
	} else {
		$mobile_login_object = new CMobileAndStudentAccess();
		if ($mobile_login_object->setDataForLogCheck($data_object->conn,$mobile_id)){
			if ($res = $mobile_login_object->dbFetchArr()) {
				$ses_arr = array();
				$ses_arr['student_nam'] = $data_arr['student_nam'];
				$ses_arr['student_id'] = $data_arr['student_id'];
				$ses_arr['status'] = $data_arr['status'];
				$ses_arr['grade'] = $data_arr['grade'];
				$_SESSION[SESSION_USR] = $ses_arr;
			}
			$mobile_login_object->dbFreeResult();
		}
		$data_object->closeDB();
	}
}

if (!isset($_SESSION[SESSION_USR])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."usr/login.php");
	exit;
}
$ses_arr = $_SESSION[SESSION_USR];
//桼ξ
$st_nam = $ses_arr['student_nam'];
$st_id	= $ses_arr['student_id'];
$st_status = $ses_arr['status'];
$st_grade = $ses_arr['grade'];

$practice_id = "";
$err_msg = "";
$practice_text = "";
$dep_id = 0;

if (!isset($_GET['practice_id']) || !is_numeric($_GET['practice_id'])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."usr/login.php");
	exit;
}
$practice_id = $_GET['practice_id'];

$data_object = new CDbAccess();
if ($data_object->openDB() == false) {
	$err_msg .= $data_object->err_msg;
} else {
	$practice_object = new CPracTableAccess();
	$prac_data = $practice_object->getDetailPracticeData($data_object->conn,$practice_id);
	if ($prac_data == false) {
		$err_msg .= "Failed to get practice data";
	} else {
		$practice_text .= "<h2>".htmlspecialchars($prac_data['practice_title'],3)."</h2>";
		$practice_text .= source2Html($prac_data['practice_text'])."<p/>";
		$img_file = $prac_data['img_file'];
		if ($img_file <> "") {
			if ($mobile_id <> "") {
				$practice_text .="<img src='".LOCAL_URL."img_files/prac_".$practice_id."/".$img_file."' width='200' height='150' /><p/>";
			} else {
				$practice_text .="<img src='".LOCAL_URL."img_files/prac_".$practice_id."/".$img_file."' width='300' height='200' /><p/>";
			}
		}

		$av_file = $prac_data['av_file'];
		if ($av_file <> "" && $av_file <> null) {
			$practice_text .="<embed src='".LOCAL_URL."av_files/prac_".$practice_id."/".$av_file."' autostart='false' width='300' height='200' /><p/>";
		}

		$dep_id = intval($prac_data['department']);
		if ($prac_data['answer'] == 1 || $prac_data['answer'] == 2) {
			//
			$ans_form_init = "";
			//Ϥ
			if ($prac_data['answer'] ==1) {
				$ans_form_init = "<INPUT TYPE='RADIO' NAME='";
				$ans_form_init .= $practice_id."' VALUE='";
			}
			if ($prac_data['answer'] ==2) {
				$ans_form_init = "<INPUT TYPE='CHECKBOX' NAME='";
				$ans_form_init .= $practice_id."[]' VALUE='";
			}
			$item_object = new CPracItemTableAccess();
			$item_object->setItemPerPracticeArr ($data_object->conn,$practice_id);
			while ($item_data = $item_object->dbFetchArr()){
				$practice_text .= $ans_form_init.$item_data['item_order']."'/>";
				$practice_text .= "<b>".$item_data['item_order']."</b> ";
				$practice_text .= source2Html($item_data['item_txt'])."<br/>";
			}
			$item_object->dbFreeResult();
		} else {
			$practice_text .= "<INPUT TYPE='TEXT' NAME='".$practice_id."'/><p/>";
		}
	}
	$data_object->closeDB();
}
$show_data = file_get_contents(TEMPLATE_DIR.'usr_recommend/usr_do_one_prac.tpl');

$show_data = str_replace(':ERR_MSG:', $err_msg, $show_data);
$show_data = str_replace(':PRAC_TEXT_REP:', $practice_text, $show_data);
$show_data = str_replace(':PRAC_ID_REP:', intval($practice_id), $show_data);
$show_data = str_replace(':DEP_ID_REP:', $dep_id, $show_data);
$show_data = str_replace(':START_TIME_REP:', time(), $show_data);
$show_data = str_replace(':SESDATA_REP:', $sis_id, $show_data);

echo $show_data;

?>