<?php
/*ϻǡԽե
 *
 */
require_once '../../data/constant.php';
require_once '../../util/make_item.php';
require_once '../../data/db_access.php';
require_once '../../data/table_access.php';
require_once '../../util/for_moshi.php';
require_once '../../util/post_util.php';

ini_set("session.save_handler","files");
session_start();
if (!isset($_SESSION[SESSION_ADMIN])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."teacher/login.php");
	exit;
}

$ses_arr = $_SESSION[SESSION_ADMIN];
$admin_status =$ses_arr['status'];
$admin_id=$ses_arr['teacher_id'];

$show_data = "";
$err_msg="";
$dif_pulldown = "";
$moshi_name = "";
$moshi_dur = 0;
$moshi_com = "";
$goal_score = 0;
$is_pub = 1;
$disp_type = 0;
$group_sel = "";
$js_arr = "";
$quiz_type_arr = array();
$full_score = 0;
$dep_num_tbl = "";
$act_type="update";
$moshi_id = "";
$del_flag = 0;
$group_nam_arr = array();

if (isset($_GET["moshi_id"]) && is_numeric($_GET["moshi_id"])) {
	$moshi_id = $_GET["moshi_id"];
	if (isset($_POST["del_flag"]) && $_POST["del_flag"] == 1) $del_flag = 1;
}
if (isset($_POST["up_id"]) && is_numeric($_POST["up_id"])) $moshi_id = $_POST["up_id"];

$data_object = new CDbAccess();
if ($data_object->openDB() == false) {
	$err_msg .= $data_object->err_msg;
} else {

	$moshi_object = new CMoshiTableAccess();
	if ($del_flag == 1) {

		if (!$moshi_object->delMoshiExe($data_object->conn,$moshi_id)) {
			$err_msg .= "Failed to delete moshi data";
		} else {
			header("Content-Type: text/html; charset=EUC-JP");
			header(URL_SET."teacher/moshi_reg/");
			exit;
		}
	}
	$moshi_object->moshiChecked($data_object->conn,$moshi_id);
	if ($ses_arr['is_cube'] == 1) {
		if (!$data_object->setCharForCube()) {
			$err_msg .= $data_object->err_msg;
		}
	}
	$group_object = new CClassInfoTableAccess();
	if ($group_object->setSelResult("*"," WHERE groupid > 3",$data_object->conn)) {
		while ($res = $group_object->dbFetchArr()) {
			$group_nam_arr[$res["groupid"]] =
				htmlspecialchars(mb_convert_encoding($res['name'],'UTF-8',XOOPS_SRT_ENCODE),ENT_QUOTES);
		}
		$group_object->dbFreeResult();
	}

	if ($ses_arr['is_cube'] == 1) {
		if (!$data_object->setCharForExam()) {
			$err_msg .= $data_object->err_msg;
		}
	}
	$moshi_form_object = new CMoshiForm();
	$moshi_form_object->setGroupNamArr($group_nam_arr);
	$moshi_form_object->setMoshiObject($moshi_object);
	$moshi_form_object->main($data_object->conn, $admin_id, $admin_status,$moshi_id);
	$dif_pulldown = $moshi_form_object->getTotalDifSel();
	$group_sel = $moshi_form_object->getClassSel();
	$js_arr = $moshi_form_object->getJsArr();
	$quiz_type_arr = $moshi_form_object->getQuizTypeSel();
	$dep_num_tbl = $moshi_form_object->getDepNumTbl();

	$moshi_name = $moshi_form_object->getMoshiName();
	$moshi_dur = $moshi_form_object->getMoshiDur();
	$moshi_com = $moshi_form_object->getMoshiCom();
	$is_pub = $moshi_form_object->getIsPub();
	$goal_score =$moshi_form_object->getGoalScore();
	$disp_type = $moshi_form_object->getDispType();

	if ($_POST <> null && isset($_POST["act_type"]) && $_POST["act_type"]== "update") {
		//ǧ̤äƤȤ
		if (isset($_POST["moshi_name"])) $moshi_name = $_POST["moshi_name"];
		if (isset($_POST["duration"])) $moshi_dur = $_POST["duration"];
		if (isset($_POST["moshi_com"])) $moshi_com = $_POST["moshi_com"];
		if (isset($_POST["is_pub"])) $is_pub = $_POST["is_pub"];
		if (isset($_POST["disptype"])) $disp_type = $_POST["disptype"];
		if (isset($_POST["goal_score"])) $goal_score = $_POST["goal_score"];
	}
	$data_object->closeDB();
}

$show_data = file_get_contents(TEMPLATE_DIR.'ad_moshi/insert_form.tpl');

$show_data = str_replace(':ERR_MSG:', $err_msg, $show_data);

$show_data = str_replace(':MOSHI_NANME_REP:', $moshi_name, $show_data);
$show_data = str_replace(':MOSHI_DUR_REP:', $moshi_dur, $show_data);
$show_data = str_replace(':MOSHI_COM_REP:', $moshi_com, $show_data);
$show_data = str_replace(':GOAL_SCORE_REP:', $goal_score, $show_data);

for ($i=0; $i<=1; $i++) {
	if ($i == $is_pub) {
		$show_data = str_replace(':IS_PUB_SEL_REP'.$i.':', "SELECTED", $show_data);
	} else {
		$show_data = str_replace(':IS_PUB_SEL_REP'.$i.':', "", $show_data);
	}
}

for ($i=0; $i<3; $i++) {
	$show_data = str_replace(':DISP_TYPE_SEL_REP'.$i.':', "", $show_data);
}

$show_data = str_replace(':TOTAL_DIFSEL_REP:', $dif_pulldown, $show_data);
$show_data = str_replace(':GROUP_SEL_REP:', $group_sel, $show_data);
$show_data = str_replace(':JS_ARR_REP:', $js_arr, $show_data);

for ($i=0; $i<10; $i++) {
	$show_data = str_replace(':TYPE_DEP_REP'.$i.':', $quiz_type_arr[$i]["department"], $show_data);
	$show_data = str_replace(':TYPE_DIF_REP'.$i.':', $quiz_type_arr[$i]["dif"], $show_data);
	$show_data = str_replace(':TYPE_LEV_REP'.$i.':', $quiz_type_arr[$i]["lev"], $show_data);
	$show_data = str_replace(':TYPE_PRAC_NUM_REP'.$i.':', $quiz_type_arr[$i]["num"], $show_data);
	$show_data = str_replace(':TYPE_PRAC_SCORE_REP'.$i.':', $quiz_type_arr[$i]["score"], $show_data);
	$show_data = str_replace(':TYPE_SUM_REP'.$i.':', ($quiz_type_arr[$i]["num"] * $quiz_type_arr[$i]["score"]), $show_data);
	$full_score += ($quiz_type_arr[$i]["num"] * $quiz_type_arr[$i]["score"]);
}
$show_data = str_replace(':FULL_SCORE_REP:', $full_score, $show_data);

$show_data = str_replace(':ERR_MSG:', $err_msg, $show_data);
$show_data = str_replace(':DEP_NUM_TBL_REP:', $dep_num_tbl, $show_data);
$show_data = str_replace(':ACT_TYPE_REP:', $act_type, $show_data);
$show_data = str_replace(':UP_ID_REP:', $moshi_id, $show_data);
$show_data = str_replace(':DEL_DISP_REP:', "inline", $show_data);

echo $show_data;
?>