<?php
require_once '../../data/constant.php';
require_once '../../util/make_item.php';
require_once '../../util/validate.php';
require_once '../../data/db_access.php';
require_once '../../data/table_access.php';
require_once '../../util/validate.php';
require_once '../../util/change_util.php';


session_start();
if (!isset($_SESSION[SESSION_USR])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."usr/login.php");
	exit;
}
$ses_arr = $_SESSION[SESSION_USR];
//桼ξ
$st_nam = $ses_arr['student_nam'];
$st_id	= $ses_arr['student_id'];
$st_status = $ses_arr['status'];
$st_grade = $ses_arr['grade'];

$practice_id = "";
$err_msg = "";
$practice_text = "";
$dep_id = 0;

if (!isset($_GET['prac_id']) || !is_numeric($_GET['prac_id'])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."usr/login.php");
	exit;
}
$practice_id = $_GET['prac_id'];

$data_object = new CDbAccess();
if ($data_object->openDB() == false) {
	$err_msg .= $data_object->err_msg;
} else {
	$practice_object = new CPracTableAccess();
	$prac_data = $practice_object->getDetailPracticeData($data_object->conn,$practice_id);
	if ($prac_data == false) {
		$err_msg .= "Failed to get practice data";
	} else {
		$practice_text .= "<h2>".htmlspecialchars($prac_data['practice_title'],3)."</h2>";
		$practice_text .= source2Html($prac_data['practice_text'])."<p/>";
		$img_file = $prac_data['img_file'];
		if ($img_file <> "") {
			$practice_text .="<img src='".LOCAL_URL."img_files/prac_".$practice_id."/".$img_file."' width='300' height='200' /><p/>";
		}
		$av_file = $prac_data['av_file'];
		if ($av_file <> "" && $av_file <> null) {
			$practice_text .="<embed src='".LOCAL_URL."av_files/prac_".$practice_id."/".$av_file."' autostart='false' width='300' height='200' /><p/>";
		}
		$dep_id = intval($prac_data['department']);
		if ($prac_data['answer'] == 1 || $prac_data['answer'] == 2) {
			//
			$ans_form_init = "";
			//Ϥ
			if ($prac_data['answer'] ==1) {
				$ans_form_init = "<INPUT TYPE='RADIO' NAME='";
				$ans_form_init .= $practice_id."' VALUE='";
			}
			if ($prac_data['answer'] ==2) {
				$ans_form_init = "<INPUT TYPE='CHECKBOX' NAME='";
				$ans_form_init .= $practice_id."[]' VALUE='";
			}
			$item_object = new CPracItemTableAccess();
			$item_object->setItemPerPracticeArr ($data_object->conn,$practice_id);
			while ($item_data = $item_object->dbFetchArr()){
				$practice_text .= $ans_form_init.$item_data['item_order']."'/>";
				$practice_text .= "<b>".$item_data['item_order']."</b> ";
				$practice_text .= source2Html($item_data['item_txt'])."<br/>";
			}
			$item_object->dbFreeResult();
		} else {
			$practice_text .= "<INPUT TYPE='TEXT' NAME='".$practice_id."'/><p/>";
		}
	}
	$data_object->closeDB();
}
$show_data = file_get_contents(TEMPLATE_DIR.'usr_prac/usr_do_one_prac.tpl');

$show_data = str_replace(':ERR_MSG:', $err_msg, $show_data);
$show_data = str_replace(':PRAC_TEXT_REP:', $practice_text, $show_data);
$show_data = str_replace(':PRAC_ID_REP:', intval($practice_id), $show_data);
$show_data = str_replace(':DEP_ID_REP:', $dep_id, $show_data);
$show_data = str_replace(':START_TIME_REP:', time(), $show_data);

echo $show_data;

?>